//+------------------------------------------------------------------+
//|    Lets Watch how Indicator Counted Acts                         |
//+------------------------------------------------------------------+
//
//
#property copyright "LukeB"
#property link      "http://www.forexfactory.com/lukeb"
//
#include <WinUser32.mqh>
#include <stdlib.mqh>
#include <stderror.mqh>

string ShortName = "Indicator Counted Display";
string Version =    "V1.00";
//
#property indicator_chart_window
#property indicator_buffers 0
//
extern string displayAtTicFrequency = " set to true for displaying on every Tic, else will display on new bars";
extern bool DisplayAtTicFrequency = true;
//
string newLine = "\n";
//
int init()
{
   IndicatorShortName(ShortName);
   return (0);
}
int deinit()
{
   Comment("");
   return (0);
}
int start()
{
   static datetime lastZeroBarTime = 0;
   static int tickCount = 0;
   bool newBar;
   tickCount ++;
   if ( Time[0] != lastZeroBarTime ) // A new Bar Zero has been made.
   {
      lastZeroBarTime = Time[0];     // update the bar time
      newBar = true;
   } else
   {
      newBar = false;
   }
   if (DisplayAtTicFrequency)       // see it every time the start function is called
   {
      CountComment(tickCount, newBar);
   } else if (newBar)              // see it only when a new bar is created
   {  
      CountComment(tickCount, newBar);
   }
   return (0);
}
void CountComment(int tickCount, bool newBar)  // Display the comment
{
   int maxCommentRows = 20;       // how many rows of comment before the comment is cleared
   static string commentString;   // String to build for displaying
   static int    callCount=0;     // Track how many times this function is called, use to clear the comment.
   commentString = StringConcatenate(commentString,"Indicator Counted: ",IndicatorCounted(),
                   " Total Bars: ",Bars," Tick Count: ",tickCount,newLine);   // Build the comment string
   if ( newBar && (DisplayAtTicFrequency == true) )
   {
      commentString = StringConcatenate(commentString,"New Bar",newLine);     // display when a new bar occurs
   }
   Comment(commentString);        // Display  the comment String
   callCount++;
   if (MathMod(callCount,maxCommentRows)<1)  // Mod yeilds 0 every maxCommentRos
   {
      commentString = "";        // Clear the comment string
   }
}

